(* Title:  "Minisubpbl/100-init-rootpbl-NEXT_STEP.sml"
   Author: Walther Neuper 2307
*)

open Ctree;
open Pos;
open TermC;
open Istate;
open Tactic;
open I_Model;
open Pre_Conds;
open Rewrite;
open Step;
open Specify;
open LItool;
open LI;

"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
tracing "--- Minisubplb/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Model_Problem = tac
val return_do_next_Model_Problem as xxx = 
      Step.do_next p ((pt, e_pos'), []);
val return_do_next_Model_Problem as ("ok", ([(Specify_Theory "Test", _, _)], _, _))
  = Step.do_next p ((pt, e_pos'), []);
(*/------------------- step into do_next_Model_Problem -------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);
           switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);
           specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
    val (_, (p_', tac as Specify_Theory "Test")) =
   Specify.find_next_step ptp;
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*then*);
           for_problem ctxt oris (o_refs, refs) (pbl, met);
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met)) =
  (ctxt, oris, (o_refs, refs), (pbl, met));
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI
    val (preok as true, xxx) =
 Pre_Conds.check ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
(*+*)val "[\n(1, [1], true ,#Given, (Cor_TEST equality (x + 1 = 2) ,(e_e, [x + 1 = 2]), Position.T)), \n(2, [1], true ,#Given, (Cor_TEST solveFor x ,(v_v, [x]), Position.T)), \n(3, [1], true ,#Find, (Cor_TEST solutions L ,(v_v'i', [L]), Position.T))]"
  = I_Model.OLD_to_TEST pbl |> I_Model.to_string_TEST @{context};
(*+*)val "[precond_rootpbl v_v]" = where_ |> UnparseC.terms @{context};
"~~~~~ fun check , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
      val (_, env_model, (env_subst, env_eval)) = of_max_variant model_patt i_model
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
(*+*)val [] = env_subst
(*+*)val [(false, Const ("Test.precond_rootpbl", _) $ Free ("v_v", _))] = pres_subst
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
(*+*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]"
  = env_model |> Subst.to_string @{context}
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = pres_subst_other
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
(*+*)val [] = env_eval
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = full_subst
      val evals = map (eval ctxt where_rls) full_subst
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = evals
val return_check_OLD = (foldl and_ (true, map fst evals), pres_subst_other)
(*+*)val (true, [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))]) = return_check_OLD
(*|------------------- contine do_next_Model_Problem -----------------------------------------*)
(*\------------------- step into do_next_Model_Problem -------------------------------------//*)
val (_, ([(tac as Specify_Theory "Test", _, _)], _, (pt, p))) = return_do_next_Model_Problem;
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Problem ["sqroot-test", "univariate", "equation", "test"] = tac

(*[], Met*)val return_Step_do_next_Specify_Problem = Step.do_next p ((pt, e_pos'), []);(*Specify_Method ["Test", "squ-equ-test-subpbl1"]*)
(*/------------------- step into Step.do_next_Specify_Problem ------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val _ =
    (*case*) tac (*of*);

Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Method id), (pt, pos)) =
  (tac, (pt, (p, p_')));

      val (o_model, ctxt, i_model) =
Specify_Step.complete_for id (pt, pos);
"~~~~~ fun complete_for , args:"; val (mID, (ctree, pos)) = (id, (pt, pos));
    val {origin = (o_model, _, _), probl = i_prob, ctxt,
       ...} = Calc.specify_data (ctree, pos);
    val {model = m_patt, where_, where_rls, ...} = MethodC.from_store ctxt mID
    val {origin = (root_model, _, _), ...} = Calc.specify_data (ctree, ([], Pos.Und))
    val (o_model', ctxt') = O_Model.complete_for m_patt root_model (o_model, ctxt)

    val (_, (i_model, _)) =
   M_Match.by_i_models ctxt i_prob (m_patt, where_, where_rls) o_model';
"~~~~~ fun by_i_models , args:"; val (ctxt, pbl, (pbt, where_, where_rls), oris) =
  (ctxt, i_prob, (m_patt, where_, where_rls), o_model');
 (*0*)val mv = Pre_Conds.max_variant pbl;

      fun eqdsc_pbt_itm ((_,(d,_))) (_, _, _, _, itm_) = d = I_Model.descriptor itm_;
      fun notmem pbl pbt1 = case find_first (eqdsc_pbt_itm pbt1) pbl of
				SOME _ => false | NONE => true;
 (*1*)val mis = (filter (notmem pbl)) pbt;
      fun eqdsc_ori (_,(d,_)) (_, _, _, d', _) = d = d';
      fun ori2itmMis (f, (d, pid)) (i, v, _, _, _) = (i, v, false, f, I_Model.Mis (d, pid));
 (*2*)fun oris2itms oris mis1 = ((map (ori2itmMis mis1)) o (filter (eqdsc_ori mis1))) oris;
      val news = (flat o (map (oris2itms oris))) mis;
 (*3*)fun mem_vat (_, vats, _, _, _) = member op = vats mv;
      val newitms = filter mem_vat news;
 (*4*)val itms' = pbl @ newitms;

      val (pb, where_') =
 Pre_Conds.check ctxt where_rls where_ (m_patt, I_Model.OLD_to_TEST itms');
"~~~~~ fun check , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (m_patt, I_Model.OLD_to_TEST itms'));
      val (_, env_model, (env_subst, env_eval)) = of_max_variant model_patt i_model
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)

(*+*)val "Test" = ctxt |> Proof_Context.theory_of  |> ThyC.id_of
(*+*)val Rule_Set.Repeat {id = "prls_met_test_squ_sub", ...} = where_rls
(*+*)val [(true, tTEST as Const ("Test.precond_rootmet", _) $ Free ("x", xxx))] = pres_subst_other

(*+*)val ctxt = Config.put rewrite_trace true ctxt;
      val evals = map (
 Pre_Conds.eval ctxt where_rls) full_subst;
(*
@## rls: prls_met_test_squ_sub on: precond_rootmet x 
@### try calc: "Test.precond_rootmet" 
@#### eval asms: "(precond_rootmet x) = True" 
@### calc. to: True 
@### try calc: "Test.precond_rootmet" 
@### try calc: "Test.precond_rootmet" 
*)
(*+*)val ctxt = Config.put rewrite_trace false ctxt;

"~~~~~ fun eval_precond_rootmet , args:"; val ((thmid:string), _, (t as (Const (\<^const_name>\<open>Test.precond_rootmet\<close>, _) $ arg)), ctxt) =
  ("aaa", "bbb", tTEST, ctxt);
    SOME (TermC.mk_thmid thmid (UnparseC.term ctxt arg) "",
      HOLogic.Trueprop $ (TermC.mk_equality (t, @{term True})))
;
    (TermC.mk_thmid thmid (UnparseC.term ctxt arg)) "";
"~~~~~ fun mk_thmid , args:"; val (thmid, n1, n2) = (thmid, (UnparseC.term ctxt arg), "");
  thmid ^ (cut_longid n1) ^ "_" ^ (cut_longid n2);

      (cut_longid n2);
"~~~~~ fun cut_longid , args:"; val (dn) = (n2);
(*\------------------- step into Step.do_next_Specify_Problem ------------------------------//*)
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Specify_Problem; val Specify_Method ["Test", "squ-equ-test-subpbl1"] = tac;

(*[1], Frm*)val return_Step_do_next_Specify_Method = Step.do_next p ((pt, e_pos'), []);(*Apply_Method ["Test", "squ-equ-test-subpbl1"]*)
(*/------------------- step into do_next_Specify_Method ------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

           switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

           specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
(*+*)val Tactic.Apply_Method mI =
    (*case*) tac (*of*);

  	    LI.by_tactic (Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty))
  	      ist_ctxt (pt, (p, p_'));
"~~~~~ fun by_tactic , args:"; val ((Tactic.Apply_Method' (mI, _, _, _)), (_, ctxt), (pt, pos as (p, _))) =
  ((Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty)),
  	      ist_ctxt, (pt, (p, p_')));
         val (itms, oris, probl) = case get_obj I pt p of (*STILL asms=[]*)
           PblObj {meth = itms, origin = (oris, _, _), probl, ...} => (itms, oris, probl)
         | _ => raise ERROR "LI.by_tactic Apply_Method': uncovered case get_obj"
         val {model, ...} = MethodC.from_store ctxt mI;
         val itms = if itms <> [] then itms else I_Model.complete oris probl [] model

         val return_init_pstate = case
           LItool.init_pstate ctxt (I_Model.OLD_to_TEST itms) mI of
             (is as Pstate {env, ...}, ctxt, program) => (is, env, ctxt, program)
(*#------------------- un-hide local of init_pstate -----------------------------------------\*)
fun msg_miss ctxt sc metID caller f formals actuals =
  "ERROR in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"" ^ caller ^ "\":\n" ^
	"formal arg \"" ^ UnparseC.term ctxt f ^ "\" doesn't match any actual arg.\n" ^
	"with:\n" ^
	(string_of_int o length) formals ^ " formal args: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	(string_of_int o length) actuals ^ " actual args: " ^ UnparseC.terms ctxt actuals
fun msg_miss_type ctxt sc metID f formals actuals =
  "ERROR in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"assoc_by_type\":\n" ^
	"formal arg \"" ^ UnparseC.term ctxt f ^ "\" of type \"" ^ UnparseC.typ ctxt (type_of f) ^
  "\" doesn't mach any actual arg.\nwith:\n" ^
	(string_of_int o length) formals ^ " formal args: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	(string_of_int o length) actuals ^ " actual args: " ^ UnparseC.terms ctxt actuals ^ "\n" ^
  "   with types: " ^ (strs2str o (map ((UnparseC.typ ctxt) o type_of))) actuals
fun msg_ambiguous ctxt sc metID f aas formals actuals =
  "AMBIGUITY in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"assoc_by_type\":\n" ^
  "formal arg. \"" ^ UnparseC.term ctxt f ^ "\" type-matches with several..."  ^
  "actual args. \"" ^ UnparseC.terms ctxt aas ^ "\"\n" ^
  "selected \"" ^ UnparseC.term ctxt (hd aas) ^ "\"\n" ^
	"with\n" ^
	"formals: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	"actuals: " ^ UnparseC.terms ctxt actuals
fun trace_init ctxt metID =
  if Config.get ctxt LI_trace
  then tracing("@@@ program \"" ^ strs2str metID ^ "\"")
  else ();

fun assoc_by_type ctxt f aa prog met_id formals actuals =
  case filter (curry (fn (f, a) => type_of f = type_of a) f) aa of
    [] => raise ERROR (msg_miss_type ctxt prog met_id f formals actuals)
  | [a] => (f, a)
  | aas as (a :: _) => (writeln (msg_ambiguous ctxt prog met_id f aas formals actuals); (f, a));
(*
  fun assoc_formals_actuals: at "PIDE turn 11" ONLY syntax revised, NOT semantics
  Env.T ->         (* [] for building return Env.T         *)
  term list ->     (* changed during building return Env.T *)
  term list ->     (* changed during building return Env.T *)
  Proof.context -> (*                                      *)
  term ->          (* program code                         *)
  MethodC.id ->    (* for error msg                        *)
  term list ->     (* original value, unchanged            *)
  term list ->     (* original value, unchanged            *)
  Env.T            (* return Env.T                         *)
*)
fun relate_args _ (f::_) [] ctxt prog met_id formals actuals =
    raise ERROR (msg_miss ctxt prog met_id "relate_args" f formals actuals)
  | relate_args env [] _ _ _ _ _ _ = env (*may drop Find?*)
  | relate_args env (f::ff) (aas as (a::aa)) ctxt prog met_id formals actuals = 
    if type_of f = type_of a 
    then relate_args (env @ [(f, a)]) ff aa ctxt prog met_id formals actuals
    else
      let val (f, a) = assoc_by_type ctxt f aas prog met_id formals actuals
      in relate_args (env @ [(f, a)]) ff (remove op = a aas) ctxt prog met_id formals actuals end
;
(*+*)relate_args: Env.T -> term list -> term list -> Proof.context -> term -> MethodC.id ->
    term list -> term list -> Env.T;
(*#------------------- un-hide local of init_pstate -----------------------------------------/*)

(*//------------------ step into init_pstate -----------------------------------------------\\*)
val (_, ctxt, i_model, met_id) = (prog_rls, ctxt, itms, mI);
"~~~~~ fun init_pstate , args:"; val (ctxt, i_model, met_id) =
    (ctxt, I_Model.OLD_to_TEST i_model, met_id);
    val (model_patt, program, prog, prog_rls, where_, where_rls) =
      case MethodC.from_store ctxt met_id of
        {model = model_patt, program = program as Rule.Prog prog, prog_rls, where_, where_rls,...} =>
          (model_patt, program, prog, prog_rls, where_, where_rls)
      | _ => raise ERROR ("init_pstate with " ^ MethodC.id_to_string met_id)

    val return_of_max_variant = 
   I_Model.of_max_variant model_patt i_model;
(*///----------------- step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);

(*+*)i_model: I_Model.T_TEST;

    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
(*+*)val [3] = sums_corr;

    val sum_variant_s = arrange_args sums_corr (1, all_variants)
(*+*)val [(3, 1)] = sum_variant_s;

    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
(*+*)val 1 = max_variant;

    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
(*+*)val 3 = length i_model_max;

    val equal_descr_pairs =
      map (get_equal_descr i_model) model_patt
      |> flat
(*+*)val 3 = length equal_descr_pairs; (*only 1 variant in this test*)

    val env_model = make_env_model equal_descr_pairs
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
(*+*)val ([], []) = (env_subst, env_eval)
(*+*)if (equal_descr_pairs |> descr_pairs_to_string @{context}) = "[" ^
  "((#Given, (equality, e_e)), " ^
    "(1, [1], true ,#Given, (Cor_TEST equality (x + 1 = 2) ,(e_e, [x + 1 = 2]), Position.T))), " ^
  "((#Given, (solveFor, v_v)), " ^
    "(2, [1], true ,#Given, (Cor_TEST solveFor x ,(v_v, [x]), Position.T))), " ^
  "((#Find, (solutions, v_v'i')), " ^
    "(3, [1], true ,#Find, (Cor_TEST solutions L ,(v_v'i', [L]), Position.T)))]"
  then () else error "equal_descr_pairs CHANGED";

(*|||----------------- contine of_max_variant ------------------------------------------------*)
    val subst_eval_list = make_envs_preconds equal_givens
    val (env_subst, env_eval) = split_list subst_eval_list

val return_of_max_variant_step = (i_model_max, env_model, (env_subst, env_eval));
(*+*)if return_of_max_variant_step = return_of_max_variant then () else error "<>";
(*+*) val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]"
  = env_model |>Subst.to_string @{context};
(*+*)if return_of_max_variant_step = return_of_max_variant then () else error "<>";
(*\\\----------------- step into of_max_variant --------------------------------------------\\*)
val (_, env_model, (env_subst as [], env_eval as [])) = return_of_max_variant
 
(*||------------------ continue init_pstate ------------------------------------------------\\*)
    val actuals = map snd env_model
(*+*)val "[x + 1 = 2, x, L]" = actuals |> UnparseC.terms @{context}
(*+*)val [_, Free ("x", _), Free ("L", typ)] = actuals
(*+*)val Type ("List.list", [Type ("HOL.bool", [])]) = typ

    val formals = Program.formal_args prog
(*+*)val "[e_e, v_v]" = (formals |> UnparseC.terms @{context})

(*+*)val "minisubpbl e_e v_v =\n(let e_ea =\n       (Try (Rewrite_Set ''norm_equation'') #>\n        Try (Rewrite_Set ''Test_simplify''))\n        e_e;\n     L_La =\n       SubProblem\n        (''Test'', [''LINEAR'', ''univariate'', ''equation'', ''test''],\n         [''Test'', ''solve_linear''])\n        [BOOL e_e, REAL v_v]\n in Check_elementwise L_L {v_v. Assumptions})" =
  (prog |> UnparseC.term @{context})

    val preconds = Pre_Conds.check_envs ctxt where_rls where_ (env_model, (env_subst, env_eval))

(*||------------------ continue init_pstate ------------------------------------------------\\*)
    val ctxt = ctxt |> ContextC.insert_assumptions (map snd (snd preconds));
    val ist = Istate.e_pstate
      |> Istate.set_eval prog_rls
      |> Istate.set_env_true (relate_args [] formals actuals ctxt prog met_id formals actuals);
(*+*)                        (relate_args [] formals actuals ctxt prog met_id formals actuals);
(*+*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\"]" =
                             (relate_args [] formals actuals ctxt prog met_id formals actuals)
       |> Subst.to_string @{context}

val return_init_pstate_steps = (* = return_init_pstate*)
    (Istate.Pstate ist, ctxt, program)
(*\\------------------ step into init_pstate -----------------------------------------------//*)
val (is, env, ctxt, prog) = return_init_pstate;

(*|------------------- continuing do_next_Specify_Method -------------------------------------*)
(*\------------------- step into do_next_Specify_Method ------------------------------------//*)
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Specify_Method; val Apply_Method ["Test", "squ-equ-test-subpbl1"] = tac;

(*[1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Rewrite_Set "norm_equation" = tac

(*[1], Res*)val return_Step_do_next_Rewrite_Set = Step.do_next p ((pt, e_pos'), []);
(*/------------------- step into do_next_Apply_Method --------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p ,((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos))
  = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*else*);

        LI.do_next (pt, input_pos);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

val return_LI_find_next_step = (*case*)
        LI.find_next_step sc (pt, pos) ist ctxt (*of*);
(*//------------------ step into LI.find_next_step -----------------------------------------\\*)
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Istate.Pstate ist), ctxt) =
  (sc, (pt, pos), ist, ctxt);
(*.. this showed that we have ContextC.empty*)
(*\\------------------ step into LI.find_next_step -----------------------------------------//*)
val LI.Next_Step (ist, ctxt, tac) = return_LI_find_next_step;

        LI.by_tactic tac (ist, Tactic.insert_assumptions tac ctxt) ptp;
"~~~~~ fun by_tactic , args:"; val (tac_, ic, (pt, pos))
  = (tac, (ist, Tactic.insert_assumptions tac ctxt), ptp);
      val pos = next_in_prog' pos

 	    val (pos', c, _, pt) =
Solve_Step.add_general tac_ ic (pt, pos);
"~~~~~ fun add_general , args:"; val (tac, ic, cs)
  = (tac_, ic, (pt, pos));
 (*if*) Tactic.for_specify' tac (*else*);

Solve_Step.add tac ic cs;
"~~~~~ fun add , args:"; val ((Tactic.Rewrite_Set' (_, _, rls', f, (f', asm))), (is, ctxt), (pt, (p, _)))
  = (tac, ic, cs);
      val (pt, c) = Ctree.cappend_atomic pt p (is, ctxt) f 
        (Tactic.Rewrite_Set (Rule_Set.id rls')) (f', asm) Ctree.Complete
      val pt = Ctree.update_branch pt p Ctree.TransitiveB

val return =
      ((p, Pos.Res), c, Test_Out.FormKF (UnparseC.term ctxt f'), pt)
(*\------------------- step into do_next_Apply_Method --------------------------------------//*)
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Rewrite_Set

(* final test ... ----------------------------------------------------------------------------*)
(*+*)val ([2], Res) = p;
Test_Tool.show_pt_tac pt; (*[
([], Frm), solve (x + 1 = 2, x)
. . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"], 
([1], Frm), x + 1 = 2
. . . . . . . . . . Rewrite_Set "norm_equation", 
([1], Res), x + 1 + - 1 * 2 = 0
. . . . . . . . . . Rewrite_Set "Test_simplify", 
([2], Res), - 1 + x = 0
. . . . . . . . . . Check_Postcond ["sqroot-test", "univariate", "equation", "test"]]   ..INCORRECT
*)
